*************************************************
*                                               *
*                CACHES OFF                     *
*              --------------                   *
*                                               *
* Schaltet die Caches bei 68020/68030/68040-    *
* Prozessoren ab                                *
*                                               *
*************************************************

EXECBASE    = 4
SUPERVISOR  =-30

SWITCHCACHESOFF:
    MOVE.L  (EXECBASE).W,A6
    MOVE.W  296(A6),D0
    BTST    #1,D0
    BEQ.S   NOCACHE
    BTST    #3,D0
    BNE.S   CACHE40
CACHE20_30:
    LEA CACHEOFF20_30(PC),A5
    JSR SUPERVISOR(A6)
    BRA.S   NOCACHE
CACHE40:
    LEA CACHEOFF40(PC),A5
    JSR SUPERVISOR(A6)
NOCACHE:
    RTS

CACHEOFF40:
    OR.W    #$700,SR
    MOVEQ   #0,D2
    NOP
    LINE_F  #$04F8
    NOP
    DC.W    $4E7B,$2002
    NOP
    RTE

CACHEOFF20_30:
    OR.W    #$700,SR
    MOVE.L  #$E0E,D2
    NOP
    DC.W    $4E7B,$2002
    NOP
    RTE
